<?php
/*
Plugin Name: HTML5 Webcam Microphone Recorder Forms
Plugin URI: https://fanspaysite.com
Description:  <strong>HTML5 Webcam Microphone Recorder Forms</strong> enables inserting webcam/microphone recordings into forms as inline fields. Implements a shortcode that generates a recording field. <a href='https://videowhisper.com/tickets_submit.php'>Support</a>
Version: 2.1.12
Author: VideoWhisper.com
Author URI: https://videowhisper.com/
Contributors: videowhisper, VideoWhisper.com
*/


//Legacy "comments" folder removed: available in v1.92.8 and older

require_once plugin_dir_path( __FILE__ ) .'/inc/options.php';
require_once plugin_dir_path( __FILE__ ) .'/inc/h5videochat.php';

use VideoWhisper\InlineRecorder;

if (!class_exists("VWinlineRecorder"))
{
	class VWinlineRecorder {

		use VideoWhisper\InlineRecorder\Options;
		use VideoWhisper\InlineRecorder\H5Videochat;
	
		public function __construct()
		{
		}


		function VWinlineRecorder()
		{
			//constructor
			self::__construct();
		}
	
		function plugins_loaded()
		{



			add_shortcode('videowhisper_recorder_inline', array( 'VWinlineRecorder', 'videowhisper_recorder_inline'));

			//web app ajax calls
			add_action( 'wp_ajax_vw_irec_app', array('VWinlineRecorder', 'vw_irec_app') );
			add_action( 'wp_ajax_nopriv_vw_irec_app', array('VWinlineRecorder', 'vw_irec_app') );


			$plugin = plugin_basename(__FILE__);
			add_filter("plugin_action_links_$plugin",  array('VWinlineRecorder', 'settings_link') );
	
		}



	}



}
//instantiate
if (class_exists("VWinlineRecorder"))
{
	$inlineRecorder = new VWinlineRecorder();
}

//Actions and Filters
if (isset($inlineRecorder))
{
	
	add_action('plugins_loaded', array(&$inlineRecorder, 'plugins_loaded'));
	add_action('admin_menu', array(&$inlineRecorder, 'admin_menu'));
	add_action( 'admin_bar_menu', array(&$inlineRecorder, 'admin_bar_menu'),90 );

}
?>